=== modified file 'drizzled/data_home.h'
--- drizzled/data_home.h	2010-09-22 07:05:47 +0000
+++ drizzled/data_home.h	2010-09-26 01:21:36 +0000
@@ -27,6 +27,8 @@
 
 std::string& getDataHome();
 std::string& getDataHomeCatalog();
+char *getDatadir();
+char **getDatadirPtr();
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-09-22 07:05:47 +0000
+++ drizzled/drizzled.cc	2010-09-26 01:21:36 +0000
@@ -364,6 +364,7 @@
 vector<string> unknown_options;
 vector<string> defaults_file_list;
 po::variables_map vm;
+char * data_dir_ptr;
 
 po::variables_map &getVariablesMap()
 {
@@ -381,6 +382,16 @@
   static string data_home_catalog(getDataHome());
   return data_home_catalog;
 }
+
+char *getDatadir()
+{
+  return data_dir_ptr;
+}
+
+char **getDatadirPtr()
+{
+  return &data_dir_ptr;
+}
  
 /****************************************************************************
 ** Code to end drizzled
@@ -519,6 +530,8 @@
   COND_server_end.notify_all();
   LOCK_thread_count.unlock();
 
+  char **data_home_ptr= getDatadirPtr();
+  delete[](*data_home_ptr);
   /*
     The following lines may never be executed as the main thread may have
     killed us

=== modified file 'drizzled/main.cc'
--- drizzled/main.cc	2010-09-23 01:53:13 +0000
+++ drizzled/main.cc	2010-09-26 01:21:36 +0000
@@ -65,6 +65,7 @@
 static pthread_t select_thread;
 static uint32_t thr_kill_signal;
 
+
 /**
   All global error messages are sent here where the first one is stored
   for the client.
@@ -264,6 +265,10 @@
                     getDataHome().c_str());
       unireg_abort(1);
     }
+    /* TODO: This is a hack until we can properly support std::string in sys_var*/
+    char **data_home_ptr= getDatadirPtr();
+    *data_home_ptr= new char[getDataHome().size()+1] ();
+    memcpy(*data_home_ptr, getDataHome().c_str(), getDataHome().size());
     getDataHomeCatalog()= "./";
     getDataHome()= "../";
   }

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2010-09-22 07:05:47 +0000
+++ drizzled/set_var.cc	2010-09-26 01:21:36 +0000
@@ -144,7 +144,7 @@
                                                     fix_completion_type);
 static sys_var_collation_sv
 sys_collation_server(&vars, "collation_server", &system_variables::collation_server, &default_charset_info);
-static sys_var_const_str       sys_datadir(&vars, "datadir", getDataHome().c_str());
+static sys_var_const_str       sys_datadir(&vars, "datadir", getDatadir());
 
 static sys_var_session_uint64_t	sys_join_buffer_size(&vars, "join_buffer_size",
                                                      &system_variables::join_buff_size);

